<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <div>
      <v-row justify="space-between" align="center">
        <v-col cols="1">
          <v-icon large>mdi-tape-measure</v-icon>
        </v-col>
        <v-col cols="5">
            <h2>
              {{workload.name}}
            </h2>
        </v-col>
        <v-col cols="6" align="right">
            <v-card-actions align="right">
              <v-spacer></v-spacer>
              <v-btn small :disabled="!enabledActions.edit" @click="$emit('editWorkload', workload)">Edit</v-btn>
              <v-btn small :disabled="!enabledActions.create" @click="$emit('specializeWorkload', {categories:[], grants:{owner:'usr:'+getProfile.preferred_username}, workload_name: M.WL_DEFAULT_WORKLOADNAME, tool_name:workload.tool_name, parent_workload:workload, parent_workload_id:workload.id})">Specialize</v-btn>
              <v-btn small :disabled="!enabledActions.clone" @click="$emit('cloneWorkload', workload)">Clone</v-btn>
              <v-btn small :disabled="!enabledActions.clone" @click="exportWorkload()">Export</v-btn>
              <v-btn small :disabled="!enabledActions.delete" v-on:click="dialog=true">Delete</v-btn>
            </v-card-actions>
        </v-col>
      </v-row>
    </div>

    <v-dialog v-model="dialog" max-width="500px"
    >
      <v-card>
        <v-card-title>
          <span>Delete workload</span>
        </v-card-title>
        <v-card-text>
        Are you sure that you want to permanently delete workload "{{workload.name}}"?
        <br/><br/>
        This action cannot be reverted.
        </v-card-text>
        <v-card-actions>
          <v-spacer/>
          <v-btn @click="dialog = false">Cancel</v-btn>
          <v-btn class="primary" v-on:click="deleteWorkload()">Delete</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="export_dialog" max-width="500px"
      v-if="resolved_workload.parent_workload"
    >
      <v-card>
        <v-card-title>
          <span>Export workload {{workload.name}} ({{workload.tool}})</span>
        </v-card-title>
        <v-card-text>
        This workload inherits from <b>{{resolved_workload.parent_workload.name}} ({{resolved_workload.parent_workload.tool}})</b>.<br/>
        How do you want to export it?<br/>
        <v-radio-group v-model="export_hierarchy">
          <v-radio label="Preserve the workload hierarchy" :value="true"></v-radio>
          <v-radio label="Collapse inherited properties in a single workload" :value="false"></v-radio>
        </v-radio-group>
        </v-card-text>
        <v-card-actions>
          <v-spacer/>
          <v-btn @click="export_dialog = false">Cancel</v-btn>
          <v-btn class="primary" v-on:click="doExportWorkload()">Export</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <MessageBox
      :model="message"
      v-on:hide="message.show=false"
    />

    <CommonHeader
      :title="MESSAGES.WL_GENERAL_SECTION_TITLE"
      :description="MESSAGES.WL_GENERAL_SECTION_DESCRIPTION"
    />
    <v-container>
      <v-row dense>
        <v-col cols="4">
          <div class="esylabel">{{M.WL_WORKLOAD_NAME}}</div> <span :class="inhStatus('prop:name')">{{resolved_workload.name}}</span>
        </v-col>
        <v-col cols="4" >
          <div class="esy-label">{{M.WL_TOOL_NAME}}</div> <span :class="inhStatus('prop:tool')">{{resolved_workload.tool}}</span>
        </v-col>
        <v-col cols="4" >
          <div class="esy-label">Maintainer</div> <span>{{resolved_workload['maintainer-name']}} ({{resolved_workload['maintainer-email']}})</span>
        </v-col>
        <v-col cols="4" >
          <div class="esy-label">Version</div> <span>{{resolved_workload.version}} (rev. {{resolved_workload.revision}})</span>
        </v-col>
        <v-col cols="4" >
          <div class="esy-label">{{M.WL_ID}}</div> {{resolved_workload.id}}
        </v-col>
      </v-row>
      <v-row v-if="resolved_workload.description">
        <v-col cols="12">
          <div class="esy-label">{{M.WL_WORKLOAD_DESCRIPTION}}</div> <span :class="inhStatus('prop:description')">{{resolved_workload.description}}</span>
        </v-col>
      </v-row>
      <v-row v-if="resolved_workload.categories && resolved_workload.categories.length>0">
        <v-col cols="12">
          <div class="esy-label">{{M.WL_CATEGORIES}}</div>
          <v-chip
            v-for="(cat) in resolved_workload.categories"
            :key="cat"
            label
            :class="'ma-1 ' +  inhStatus('cat:'+cat)"
          ><span >#{{cat}}</span></v-chip>
        </v-col>
      </v-row>
      <v-row v-if="resolved_workload.references">
        <v-col cols="12">
          <div class="esy-label">References</div>
          <ul>
            <li v-for="(v, k) in stringToJSON(resolved_workload.references)" v-bind:key="k">{{k}}: <a :href="v">{{v}}</a></li>
          </ul>
        </v-col>
      </v-row>
    </v-container>

    <CommonHeader
      subtitle="Inheritance"
      v-if="resolved_workload.abstract || resolved_workload.parent_workload || (resolved_workload.children_workloads && resolved_workload.children_workloads.length>0)"
    />

    <v-container v-if="resolved_workload.abstract">
        This is an <b>abstract</b> workload. It means it cannot be executed, but only specialized.
    </v-container>

    <v-container>
      <template v-if="resolved_workload.parent_workload">
        This workload extends
          <a @click="$emit('viewWorkload', resolved_workload.parent_workload)">
            {{resolved_workload.parent_workload.name}}
            ({{resolved_workload.parent_workload.tool}})
          </a>
        <br/>
      </template>
      <template v-if="resolved_workload.children_workloads && resolved_workload.children_workloads.length>0">
        Specializations of this workloads are:
        <span
          :key="child.id"
          v-for="(child, index) in resolved_workload.children_workloads"
        >
          <a @click="$emit('viewWorkload', child)">
            {{child.name}}
            ({{child.tool}})
          </a>
          <span v-if="index+1 < resolved_workload.children_workloads.length">, </span>
        </span>
      </template>
      <template v-if="resolved_workload.parent_workload">
        <v-switch
          v-model="highlight"
          label="Highlight properties set in this workload"
        ></v-switch>
      </template>
    </v-container>

    <CommonHeader
      :title="MESSAGES.WL_EXECUTION_SECTION_TITLE"
      :description="MESSAGES.WL_EXECUTION_SECTION_DESCRIPTION"
    />

    <CommonHeader
      :subtitle="MESSAGES.WL_INSTALL_SECTION_TITLE"
      :description="MESSAGES.WL_INSTALL_SCRIPTS_HELP"
    />
    <KeyValues
      v-if="this.getScripts('install').length>0"
      :entries="this.getScripts('install')"
    />
    <v-container v-else class="esy-novalue">
      {{M.WL_NO_INSTALL_SCRIPTS}}
    </v-container>

    <CommonHeader
      :subtitle="MESSAGES.WL_POSTINSTALL_SECTION_TITLE"
      :description="MESSAGES.WL_POSTINSTALL_SCRIPTS_HELP"
    />
    <KeyValues
      v-if="this.getScripts('postinstall').length>0"
      :entries="this.getScripts('postinstall')"
    />
    <v-container v-else class="esy-novalue">
      {{M.WL_NO_POSTINSTALL_SCRIPTS}}
    </v-container>


    <CommonHeader
      :subtitle="MESSAGES.WL_EXECUTE_SECTION_TITLE"
      :description="MESSAGES.WL_EXECUTE_SCRIPTS_HELP"
    />
    <KeyValues
      v-if="this.getScripts('execute').length>0"
      :entries="this.getScripts('execute')"
    />
    <v-container v-else class="esy-novalue">
      {{M.WL_NO_EXEC_SCRIPTS}}
    </v-container>


    <CommonHeader
      :subtitle="MESSAGES.WL_CLEANUP_SECTION_TITLE"
      :description = "MESSAGES.WL_CLEANUP_SCRIPTS_HELP"
    />
    <KeyValues
      v-if="this.getScripts('cleanup').length>0"
      :entries="this.getScripts('cleanup')"
    />
    <v-container v-else class="esy-novalue">
      {{M.WL_NO_CLEANUP_SCRIPTS}}
    </v-container>


    <div
      v-if="this.getOtherScripts().length>0"
    >
      <CommonHeader
        :subtitle="MESSAGES.WL_USER_SCRIPTS_SECTION_TITLE"
        :description = "MESSAGES.WL_USER_SCRIPTS_HELP"
      />
      <KeyValues
        :entries="this.getOtherScripts()"
      />
    </div>


    <CommonHeader
      :subtitle="MESSAGES.WL_PARAMETERS_SECTION_TITLE"
      :description = "MESSAGES.WL_WORKLOAD_PARAMETERS_HELP"
    />
    <KeyValues
      v-if="this.getWorkloadParameters().length>0"
      :entries="this.getWorkloadParameters()"
    />
    <v-container v-else>
      {{M.WL_NO_PARAMETERS}}
    </v-container>


    <CommonHeader
      :title="MESSAGES.WL_SHARING_SECTION_TITLE"
      :description="MESSAGES.WL_SHARING_SECTION_DESCRIPTION"
    />
    <v-container>
      <div v-if="sharing=='public'">
        <v-icon small>mdi-earth</v-icon> {{M.WL_PUBLIC}}
      </div>

      <div v-if="sharing=='private'">
        <v-icon small>mdi-lock</v-icon> {{M.WL_PRIVATE}}
      </div>

      <div v-if="sharing=='shared'">
        <v-icon small>mdi-share-variant</v-icon> {{M.WL_VISIBLETOME}}
      </div>
    </v-container>

    <template v-if="false">
      <CommonHeader
        :title="M.WL_RESULTS_SECTION_TITLE"
      />
      <todo>links to grafana or embedded reports... or nothing</todo>
    </template>

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import KeyValues from '../common/KeyValues.vue';
import todo from '../common/ToDo.vue';
import MessageBox from '../common/MessageBox.vue';
import { MESSAGES } from "../common/messages";
import { mapGetters } from "vuex";

import { getWorkloadSharingLevel } from '../common/benchsuite.js';

export default {

 name: 'WorkloadViewer',

 components: {
    CommonHeader,
    KeyValues,
    todo,
    MessageBox
  },

  props: {
    workloadId: {
      type: String,
      default: ''
    }
  },


  data: () => ({
    M:MESSAGES,
    MESSAGES:MESSAGES,
    workload : {grants:{}},
    resolved_workload : {grants:{}},
    dialog:false,
    export_dialog:false,
    export_hierarchy:true,
    highlight:false,
    message: {
      show: false,
      text: "",
      title: ""
    },
    enabledActions: {
      create: false,
      edit: false,
      clone: false,
      delete: false
    },
    reservedKeys : ["children_workloads", "abstract", "grants", "parent_workload", "parent_workload_id", "workload_name", "tool_name", "description", "id", "class", "parser", "categories", "workload_parameters"],
  }),

  created () {
    return this.init();
  },


  mounted () {
    this.$vuetify.goTo(document.body, {duration:200})
  },

  computed: {
    ...mapGetters(["getProfile"]),
    sharing() {
      return getWorkloadSharingLevel(this.workload);
    }
  },

  watch: {
    highlight: function (value) {
      this.toggleHighlight(value);
    },
    workloadId: function() {
      this.init();
    }

  },

  methods:{
    exportWorkload: function() {
      if(this.workload.parent_workload_id) {
        this.export_dialog=true;
      } else {
        this.doExportWorkload();
      }
    },
    doExportWorkload: function() {
      this.export_dialog=false;
      var link = document.createElement("a");
      link.setAttribute("href", this.$REST_BASE_URL + '/workloads/'+this.workloadId+'/download?hierarchy='+this.export_hierarchy);
      link.click();
    },

  init: function() {
    this.$store.commit('fbkon')

    this.$http
          .get(this.$REST_BASE_URL + '/workloads/'+this.workloadId+'?embed_parent=true&resolve=false&embed_children=true')
      .then(response => {
        this.workload = response.data;
        this.$emit("title", this.workload.name);
        this.$http
              .get(this.$REST_BASE_URL + '/workloads/'+this.workloadId+'?embed_parent=true&resolve=true&embed_children=true')
          .then(response => (this.resolved_workload = response.data))

      })
    .finally(() => {this.$store.commit('fbkoff'); this.highlight=false;});

      // update actions
      this.$http
            .get(this.$REST_BASE_URL + '/workloads/'+this.workloadId+"/user_actions")
        .then(response => {
          this.enabledActions.edit = response.data.edit=="True";
          this.enabledActions.clone = response.data.clone=="True";
          this.enabledActions.delete = response.data.delete=="True";
        })

    this.$http
          .get(this.$REST_BASE_URL + "/workloads/user_actions")
      .then(response => {
        this.enabledActions.create = response.data.create=="True";
      })

  },

     toggleHighlight: function() {
       var elements = document.querySelectorAll(".jklm")
       for(var i in elements) {
         if(elements[i].style) {
           elements[i].style.borderRadius = this.highlight ? "5px" : "";
           elements[i].style.background = this.highlight ? "greenyellow" : "";
           elements[i].style.color = this.highlight ? "black" : "";
           elements[i].style.boxShadow = this.highlight ? "0px 0px 3px 3px greenyellow" : "";

         }
       }
       elements = document.querySelectorAll(".asdf")
       for(i in elements) {
         if(elements[i].style) {
           elements[i].style.borderRadius = "";
           elements[i].style.background = "";
           elements[i].style.color = "";
           elements[i].style.boxShadow = "";
         }
       }
     },

     inhStatus: function(what) {
       if(this.workload.parent_workload_id==null)
         return "asdf";
       if(what.startsWith("prop:")) {
         what = what.substring(5);
         return this.workload[what]==null ? "asdf":"jklm";
       }
       if(what.startsWith("cat:")) {
         what = what.substring(4);
         return this.workload.categories.includes(what) ? "jklm":"asdf";
       }
       if(what.startsWith("par:") && this.workload.workload_parameters) {
         what = what.substring(4);
         return this.workload.workload_parameters[what]==null ? "asdf":"jklm";
       }
     },

     deleteWorkload: function(){
      this.$store.commit('fbkon')
       this.$http.delete(this.$REST_BASE_URL + "/workloads/"+this.workload.id)
      .then(() => {
          this.workload = null
          this.$emit("workloadDeleted")
        }
      )
      .catch(e => {console.log(e)})
      .finally(() => {this.$store.commit('fbkoff'); this.dialog=false} );
     },

    getScripts: function(command) {
      var out = [];
      for(var k in this.resolved_workload) {
        var level = this.getScriptLevel(k, command);
        if(level>0) {
          var cls = this.inhStatus("prop:"+k)+ " command";

          // try to format the field as JSON in HTML
          var strJson = this.resolved_workload[k]
          try {
            var json = this.stringToJSON(this.resolved_workload[k])
            strJson = JSON.stringify(json, null, 2);
            strJson = strJson.replace(/\\n/g, '<br/>');
          } catch (error) {
            strJson = this.resolved_workload[k]
          }

          var formatted = "<div class='"+cls+"'><pre>"+strJson.replace(/\n/g, '<br/>')+"</pre></div>";
          out.push({key:k, value:this.resolved_workload[k], formatted:formatted, weight:level, highlight:level>1, icon:"mdi-code-greater-than"});
        }
      }

      // now sort them by weight, then by name
      out.sort(function(a, b){
        var res = b.weight-a.weight
        if(res!=0)
          return res;
        return b.key < a.key;
      })

      return out;
    },

    getOtherScripts: function() {
      var out = [];
      for(var k in this.resolved_workload) {
        if(!k.startsWith("install") && !k.startsWith("postinstall") && !k.startsWith("exec") && !k.startsWith("cleanup") && !this.reservedKeys.includes(k)) {
          var cls = this.inhStatus("prop:"+k)+ " command";

          // try to format the field as JSON in HTML
          var strJson = this.resolved_workload[k]
          try {
            var json = this.stringToJSON(this.resolved_workload[k])
            strJson = JSON.stringify(json, null, 2);
            strJson = strJson.replace(/\\n/g, '<br/>');
          } catch {
            strJson = this.resolved_workload[k]
          }

          var formatted = "<div class='"+cls+"'><pre>"+strJson.replace(/\n/g, '<br/>')+"</pre></div>";
          out.push({key:k, value:this.resolved_workload[k], formatted:formatted, highlight:false, icon:"mdi-code-greater-than"});
        }
      }
      // now sort them by weight, then by name
      out.sort(function(a, b){
        return b.key < a.key;
      })
      return out;
    },

    getWorkloadParameters: function() {
      if(this.resolved_workload.workload_parameters) {
        var out = Object.entries(this.resolved_workload.workload_parameters).map(( [k, v] ) => ({ "key":k, "value":v, "additionalClass":this.inhStatus("par:"+k) }));
        // now sort them by weight, then by name
        out.sort(function(a, b){
          return b.key < a.key;
        })
        return out;
      }
      else
        return [];
    },

    stringToJSON: function(text) {
      console.log('TO JSON');
      var res = text.replace(/"/g, "\\\"");
      res = res.replace(/'/g, '"');
      res = JSON.parse(res);
      return res;
    },

    getScriptLevel: function(name, command) {
      var commands = command!=null ? "("+command+")" : "(install|postinstall|execute|cleanup)";
      var platforms = "(debian|centos|ubuntu)";
      var re = new RegExp("^"+commands+"_"+platforms+"_[0-9\\.]+$", "g");
      if(name.match(re))
        return 4;
      re = new RegExp("^"+commands+"_"+platforms+"$", "g");
      if(name.match(re))
        return 3;
      re = new RegExp("^"+commands+"$", "g");
      if(name.match(re))
        return 2;
      re = new RegExp("^"+commands, "g");
      if(name.match(re))
        return 1;
      return 0;
    }

  }

};

</script>

<style>

  div.esylabel {
    color:rgba(0, 0, 0, 0.6);
    font-size:12px;
  }
  div.esy-label-normal, span.esy-label-normal {
    color:rgba(0, 0, 0, 0.6);
  }
  .esy-novalue {
    opacity: 0.5;
  }

  div.asdf, span.asdf {
  }
  div.jklm, span.jklm {
  }

</style>
